<i18n>
{
  "fr": {
    "info-1": "Sélectionnez le code NACRES de l'achat ou faites une recherche par son intitulé. La saisie du montant est en euros.",
    "label-1": "Code NACRES",
    "label-2": "Intitulé NACRES",
    "label-3": "Montant en euros",
    "label-4": "Emissions"
  },
  "en": {
    "info-1": "Select the NACRES code of the purchase or search by its description. The entry of the amount is in euros.",
    "label-1": "NACRES code",
    "label-2": "NACRES description",
    "label-3": "Amount in euros",
    "label-4": "Emissions"
  }
}
</i18n>

<template>
  <diV>
    <form @submit.prevent="validateBeforeSubmit">
      <div class="columns">
        <div class="column is-flex is-vcentered">
          <b-notification :closable="false">
            {{ $t('info-1') }}
          </b-notification>
        </div>
        <div class="column is-5">
          <b-notification :closable="false">
            <div class="level-item has-text-centered">
              <div>
                <p class="heading has-text-carbone">
                  {{ $t('label-4') }}
                </p>
                <div class="title is-size-3 has-text-carbone">
                  <p v-if="intensity !== null">
                    {{ Math.round(intensity.intensity) | splitNumber }} &plusmn;
                    {{ Math.round(intensity.uncertainty) | splitNumber }}
                    <span class="is-size-5">{{ $t('kg.co2e') }}</span>
                  </p>
                  <p v-else>
                    ...
                    <span class="is-size-5">{{ $t('kg.co2e') }}</span>
                  </p>
                </div>
              </div>
            </div>
          </b-notification>
        </div>
      </div>
      <b-notification :closable="false">
        <div class="columns">
          <div class="column is-3">
            <b-field
              :label="$t('label-1')"
              :type="{'is-danger': errors.has('code')}"
              :message="errors.first('code')">
              <b-autocomplete
                icon="tag"
                name="code"
                clearable
                :placeholder="$t('label-1') + ' *'"
                :value="cpurchase.code"
                :open-on-focus="true"
                :data="filteredCodes"
                v-validate="'required'"
                @typing="reset"
                @input.native="event => updateDescription(event.target.value)"
                @select="updateDescription"
              />
            </b-field>
          </div>
          <div class="column">
            <b-field
              :label="$t('label-2')"
              :type="{'is-danger': errors.has('intitule')}"
              :message="errors.first('intitule')">
              <b-autocomplete
                icon="tag"
                name="intitule"
                clearable
                :placeholder="$t('label-2') + ' *'"
                :value="description"
                :open-on-focus="true"
                :data="filteredDescriptions"
                @typing="reset"
                @input.native="event => updateCode(event.target.value)"
                @select="updateCode"
              />
            </b-field>
          </div>
          <div class="column is-3">
            <b-field
              :label="$t('label-3')"
              :type="{'is-danger': errors.has('amount')}"
              :message="errors.first('amount')">
              <b-input
                name="amount"
                icon="eur"
                v-validate="'required|decimal'"
                maxlength="50"
                v-model="cpurchase.amount"
              ></b-input>
            </b-field>
          </div>
        </div>
      </b-notification>
      <hr v-if="!isSimulation">
      <nav v-if="!isSimulation" class="level">
        <div class="level-left"></div>
        <div class="buttons level-right">
          <b-button
            class="button"
            @click="$emit('close')"
            icon-left="close"
          >
            {{ $t('cancel') }}
          </b-button>
          <button
            v-show="modeCreation"
            type="submit"
            class="button is-primary"
          >
            <span class="icon is-small"><i class="sui sui-plus"></i></span>
            <span> {{ $t('add') }} </span>
          </button>
          <button
            v-show="!modeCreation"
            type="submit"
            class="button is-primary"
          >
            <span class="icon is-small"><i class="sui sui-refresh"></i></span>
            <span> {{ $t('update') }} </span>
          </button>
        </div>
      </nav>
    </form>
  </diV>
</template>

<script>
import Purchase from '@/models/carbon/Purchase.js'
import { mapGetters } from 'vuex'

export default {
  name: 'PurchaseForm',
  props: {
    purchase: {
      type: Object,
      default: function () {
        return {}
      }
    },
    modeCreation: {
      type: Boolean,
      default: false
    },
    isSimulation: {
      type: Boolean,
      default: false
    }
  },
  $_veeValidate: {
    validator: 'new'
  },
  data () {
    return {
      cpurchase: Purchase.createFromObj(this.purchase),
      description: ''
    }
  },
  watch: {
    purchase: {
      handler () {
        this.cpurchase = Purchase.createFromObj(this.purchase)
      },
      deep: true
    }
  },
  computed: {
    ...mapGetters('authentication', ['isAuthenticated']),
    GHGIYear: function () {
      return this.$store.getters['ghgi/item']['year']
    },
    intensity: function () {
      if (this.cpurchase.isValid()) {
        return this.cpurchase.getCarbonIntensity(this.GHGIYear)
      } else {
        return null
      }
    },
    filteredCodes: function () {
      return this.codes.filter((option) => {
        return option
          .toString()
          .toLowerCase()
          .indexOf(this.cpurchase.code.toLowerCase()) >= 0
      })
    },
    codes: function () {
      return Purchase.getCodes()
    },
    filteredDescriptions: function () {
      return this.descriptions.filter((option) => {
        return option
          .toString()
          .toLowerCase()
          .indexOf(this.description.toLowerCase()) >= 0
      })
    },
    descriptions: function () {
      return Purchase.getDescriptions()
    }
  },
  methods: {
    validateBeforeSubmit () {
      this.$validator.validateAll().then((result) => {
        if (result) {
          if (this.modeCreation) {
            this.$emit('add', this.cpurchase)
          } else {
            this.$emit(
              'update',
              {
                'from': this.purchase,
                'to': this.cpurchase
              }
            )
          }
        }
      })
    },
    select (code) {
      this.cpurchase.setCode(code)
    },
    updateDescription (code) {
      if (code) {
        this.cpurchase.setCode(code)
        this.description = this.cpurchase.getFactorDescription()
      }
    },
    updateCode (description) {
      if (description) {
        this.description = description
        let newCode = this.cpurchase.getCodeFromDescription(description)
        if (newCode) {
          this.cpurchase.setCode(newCode)
        }
      }
    },
    reset () {
      this.cpurchase.id = null
      this.cpurchase.code = ''
      this.description = ''
    }
  },
  mounted () {
    this.description = this.cpurchase.getFactorDescription()
  }
}
</script>

<style>
.has-text-carbone {
  color: #8e6a9e !important;
}
</style>
